#include "bcgram.h"
extern int set_err_seen();
int (*ZC_fn_eprint_exit)() = set_err_seen;
main(argc, argv)
char **argv;
{
char **new_argv, **save_argv, *s, *t, *ae_malloc(), *getenv();
int new_argc, save_argc, status, i;
static char *single[3];
static char badoptmix[] = "cannot set options -%s simultaneously";

t = badoptmix; /* supress compiler warning */
single[0] = *argv;
loopmain_init();
for(i = 1; i < argc; ++i) {
status |= loopmain(argv[i]);
}
status |= loopmain_close();

exit(status);
} /* main */

static char ZC_scanstring[700];
FILE **ZC_divertfiles[] = {
0,0};
char ZC_divertnest[] = {
0,0};
char ZC_divertchars[][4] = {
{'/','*','*','/'},
{0,0,0,0}
};
char ZC_nl_significant = 16;
char *ZC_t_names[] = { "end-of-file",
"error",
"NUMBER",
"STRING",
"NUMBER_HUGE",
"WORD",
"DOT",
"ADDOP",
"MULOP",
"POWER",
"CHOOSE",
"LP",
"RP",
"BANG",
"PRIME",
"ROOT",
"COMMA",
"EQUOP",
"EOL",
"QUOTE",
"Line_cmd",
0};
/* reserved words */
struct {
char *key;
short gramval; /* number that determines the gramatical significance of this token */
short tokval; /* number associated with this token */
short extval; /* user-defined number asssociated with this token,
	passed to other routines.
	For example, the tokens "<=", ">", etc may be given token numbers
	of 1 through 6, somewhat arbitrary, with a fixed
	grammar number of 25, since they all have the same affect on parsing.
	The extensions are numbers that tell the interpreter
	or compiler exactly how to compare the two operands. */
int (*fn)(); /* function to call if this keyword appears */
} keywords[] = {
{ "bottom", 20, 25, 0, 0},
{ "factor", 20, 23, 0, 0},
{ "ibase", 20, 20, 0, 0},
{ "mod", 20, 19, 0, 0},
{ "obase", 20, 21, 0, 0},
{ "prime", 20, 22, 0, 0},
{ "quit", 20, 18, 0, 0},
{ "sqrt", 20, 26, 0, 0},
{ "top", 20, 24, 0, 0},
{0,0,0,0,0}
};

extern int scanner_base, err_base;

int lex_go()
{
/* recall that input-character variable must be int, for EOF */
int c;
char y0, *s;
int i, left, right; /* for binary search of keywords */
short rc;
static char w[WORD_LENGTH]; /* store word */

top:
c = io_skipwhite();
i = 0;
ZC_inp_parseval.tok.val = ZC_inp_parseval.tok.extend = 0;

switch(c) {
case EOF: return 0;
case '!':
ZC_inp_parseval.tok.val = 11;
return 13;
case '"':
ZC_inp_parseval.tok.val = 17;
return change_quote(19);
case '%':
ZC_inp_parseval.tok.val = 5;
return 8;
case '\'':
ZC_inp_parseval.tok.val = 12;
return 14;
case '(':
ZC_inp_parseval.tok.val = 9;
return 11;
case ')':
ZC_inp_parseval.tok.val = 10;
return 12;
case '*':
ZC_inp_parseval.tok.val = 4;
return 8;
case '+':
ZC_inp_parseval.tok.val = 3;
return 7;
case ',':
ZC_inp_parseval.tok.val = 14;
return 16;
case '-':
ZC_inp_parseval.tok.val = 2;
return 7;
case '.':
ZC_inp_parseval.tok.val = 1;
return dot_to_poly(6);
case '/':
c = io_get();
 switch(c) {
case '/':
ZC_inp_parseval.tok.val = 8;
return 10;
default: io_unget(c);
} /* end switch on char[1] */
ZC_inp_parseval.tok.val = 6;
return 8;
case '=':
ZC_inp_parseval.tok.val = 15;
return 17;
case '@':
ZC_inp_parseval.tok.val = 13;
return 15;
case '^':
ZC_inp_parseval.tok.val = 7;
return 9;
case '\n':
ZC_inp_parseval.tok.val = 16;
return check_nl_quote(18);
} /* end switch looking for symbolic token */

if(isalpha(c) || c == '_') { /* word */
do {
if(i < WORD_LENGTH-1) w[i++] = c;
c = io_get();
} while(isalnum(c) || c == '_');
w[i] = 0;
io_unget(c);

/* look for keyword */
c = w[0];
left = -1, right = sizeof(keywords)/sizeof(keywords[0]);
while(right-left > 1) {
i = (left + right) / 2;
s = keywords[i].key;
rc = strcmp(s, w);
if(rc > 0) { right = i; continue; }
if(rc < 0) { left = i; continue; }

/* keyword found */
ZC_inp_parseval.tok.val = keywords[i].tokval;
ZC_inp_parseval.tok.extend = keywords[i].extval;
rc = keywords[i].gramval;
if(keywords[i].fn) rc = (*keywords[i].fn)(rc);
return rc;
} /* end loop searching for keywords */

ZC_inp_parseval.s = w;
return word_to_var(GRAM_WORD);
} /* end word */

if(isdigit(c)) { /* number */
y0 = 0;
ZC_scanstring[i++] = c;
c = io_get();
if(ZC_scanstring[0] == '0') {
y0 = 1; /* leading zeros */
if(toupper(c) == 'X') { ZC_scanstring[i++] = c; c = io_get(); }
} /* end looking for C style 0...octal or 0x...hex */

more_number:
if(isalnum(c)) {
do {
if(!y0 || c != '0') {
y0 = 0;
if(i < STRING_LENGTH-1) ZC_scanstring[i++] = c;
}
c = io_get();
} while(isalnum(c));
}

/* number can spread across multiple lines */
if(c == '\\') {
c = io_get();
if(c == '\n') {
c = io_get();
goto more_number;
}
}

/* number has now been read into ZC_scanstring */
io_unget(c);
ZC_scanstring[i] = 0;
if(i == STRING_LENGTH-1)
eclib_error(SCAN_LONG_STRING, STRING_LENGTH);

/* convert number into long, if possible */
i = zc_strtol(ZC_scanstring, &s, &ZC_inp_parseval.l);
if(i) {
if(i == -1) i = SCAN_BAD_DIGIT;
else {
i = SCAN_PRECISION_LONG;
ZC_inp_parseval.s = ZC_scanstring;
return numh_to_poly(GRAM_NUMBER_HUGE);
}
eclib_error(i, *s | (err_base << 8));
} /* abnormal return from zc_strtol */
return num_to_poly(GRAM_NUMBER);
} /* end number */

eclib_error(SCAN_BADCHAR, c);
goto top;
} /* lex_go */

short ZC_prod_length[]={
0,0,7,3,7,11,5,3,0,2,
5,7,7,7,7,7,5,7,9,3,
2,3,7 };
short ZC_nt_base = 50;
char *ZC_nt_names[] = {
"$start",
"input",
"line",
"exp",
"varlist",
0};

short ZC_rules[] = {
50,51,0,
51,
51,51,52,18,
52,53,
52,5,17,53,
52,5,15,2,17,53,
52,20,53,
52,20,
52,
52,1,
53,7,53,
53,53,7,53,
53,53,8,53,
53,53,9,53,
53,53,10,53,
53,11,53,12,
53,53,13,
53,53,14,5,
53,53,11,54,12,
53,5,
53,2,
54,5,
54,54,16,5,
-1};
short ZC_rule_offset[]={
0,3,4,8,10,14,20,23,25,26,
28,31,35,39,43,47,51,54,58,63,
65,67,69,73,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,
0 };
short ZC_exca[] ={
-1, 1,
	0, -1,
	18, 8,
	-2, 0,
	0,0};
short ZC_def[]={
1,-2,0,3,19,7,9,0,0,20,
2,0,0,0,0,16,0,0,0,0,
6,19,10,0,11,12,13,14,17,0,
21,4,0,15,18,0,0,22,5 };
short ZC_chk[]={
-1000,-1,-2,-3,5,20,1,7,11,2,
18,7,8,9,10,13,14,11,17,15,
-3,5,-3,-3,-3,-3,-3,-3,5,-4,
5,-3,2,12,12,16,17,5,-3 };
short ZC_yylast = 68;
short ZC_act[]={
3,6,9,10,36,4,20,7,22,23,
37,8,24,25,26,27,19,30,18,31,
5,11,12,13,14,17,33,15,16,11,
12,13,14,17,28,15,16,38,12,13,
14,17,32,15,16,13,14,17,29,15,
16,34,2,1,17,35,15,16,9,0,
0,21,0,7,0,0,0,8 };
short ZC_pact[]={
-1000,0,-15,22,1,56,-1000,56,56,-1000,
-1000,56,56,56,56,-1000,29,12,56,40,
22,-1000,30,14,30,36,43,43,-1000,39,
-1000,22,-13,-1000,-1000,5,56,-1000,22 };
short ZC_pgo[]={
0,53,52,0,48 };
char *ZC_stacktop;
char ZC_recflag; /* error recovery */
ZC_gramunion ZC_curr_parseval, ZC_inp_parseval;
short ZC_gramunion_size = sizeof(ZC_gramunion);
int ZC_curr_token;

parser_rules(prodnum)
{
switch(prodnum) {
case 2: endline();
 break;
case 3: dispexp(((ZC_gramunion *) ZC_stacktop)[-1].POLY);
 break;
case 4: assign(((ZC_gramunion *) ZC_stacktop)[-3].n,
((ZC_gramunion *) ZC_stacktop)[-1].POLY,
(struct POLY *)0);
 break;
case 5: assign(((ZC_gramunion *) ZC_stacktop)[-5].n,
((ZC_gramunion *) ZC_stacktop)[-1].POLY,
((ZC_gramunion *) ZC_stacktop)[-3].POLY);
 break;
case 6: bc_cmd(((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].POLY);
 break;
case 7: bc_cmd(((ZC_gramunion *) ZC_stacktop)[-1].tok.val,
(struct POLY *)0);
 break;
case 10: ZC_curr_parseval.POLY = mathop((struct POLY *)0,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].POLY);
 break;
case 11: ZC_curr_parseval.POLY = mathop(((ZC_gramunion *) ZC_stacktop)[-3].POLY,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].POLY);
 break;
case 12: ZC_curr_parseval.POLY = mathop(((ZC_gramunion *) ZC_stacktop)[-3].POLY,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].POLY);
 break;
case 13: ZC_curr_parseval.POLY = mathop(((ZC_gramunion *) ZC_stacktop)[-3].POLY,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].POLY);
 break;
case 14: ZC_curr_parseval.POLY = mathop(((ZC_gramunion *) ZC_stacktop)[-3].POLY,
((ZC_gramunion *) ZC_stacktop)[-2].tok.val,
((ZC_gramunion *) ZC_stacktop)[-1].POLY);
 break;
case 15: ZC_curr_parseval = ((ZC_gramunion *) ZC_stacktop)[-2]; break;
case 16: ZC_curr_parseval.POLY = pbang(((ZC_gramunion *) ZC_stacktop)[-2].POLY);
 break;
case 17: ZC_curr_parseval.POLY = pderiv(((ZC_gramunion *) ZC_stacktop)[-3].POLY,
((ZC_gramunion *) ZC_stacktop)[-1].n);
 break;
case 18: ZC_curr_parseval.POLY = subst(((ZC_gramunion *) ZC_stacktop)[-4].POLY,
((ZC_gramunion *) ZC_stacktop)[-2].l);
 break;
case 19: ZC_curr_parseval.POLY = sym_to_poly(((ZC_gramunion *) ZC_stacktop)[-1].n);
 break;
case 21: ZC_curr_parseval.l = addbit((long)0,
((ZC_gramunion *) ZC_stacktop)[-1].n);
 break;
case 22: ZC_curr_parseval.l = addbit(((ZC_gramunion *) ZC_stacktop)[-3].l,
((ZC_gramunion *) ZC_stacktop)[-1].n);
 break;
} /* end switch on production number */
return -1; /* continue parsing */
} /* parser_rules */



static char quoteflag = 0; /* in quotes */

set_err_seen() { err_seen = 1; ZC_recflag = 1; }

endline() { allfree(); ZC_recflag = 0; err_seen = 0; }

parse_error(s)
char *s;
{
eprint(s);
return 0;
} /* parse_error */


loopmain_init()
{
scanner_base = 10;
} /* loopmain_init */

loopmain(s)
char *s;
{
if(!pushstream(s))
parse_go();
} /* loopmain */

loopmain_close()
{
if(!pushstream("-"))
parse_go();
} /* loopmain_close */

check_nl_quote(n)
{
if(quoteflag) eprint("missing closing quote");
quoteflag = 0;
return n;
} /* check_nl_quote */

change_quote(n)
{
quoteflag ^= 1;
return quoteflag ? GRAM_LP : GRAM_RP;
} /* change_quote */

dispexp(p)
struct POLY *p;
{
if(err_seen) return;
pdisp(p);
printf("\n");
} /* dispexp */

numh_to_poly()
{
struct POLY *p = newpoly(1);
p->terms[0].coef = string_to_vint(ZC_inp_parseval.s);
ZC_inp_parseval.POLY = p;
return GRAM_NUMBER;
} /* numh_to_poly */

num_to_poly()
{
long l = ZC_inp_parseval.l;
struct POLY *p = &pzero;
if(l) {
p = newpoly(1);
p->terms[0].coef = long_to_vint(l);
}
ZC_inp_parseval.POLY = p;
return GRAM_NUMBER;
} /* num_to_poly */

word_to_var()
{
char *s = ZC_inp_parseval.s;
ZC_inp_parseval.n = 0;

if(!islower(s[0]) || s[1])
eprint("sorry, evolution, only one letter variable names");
else
ZC_inp_parseval.n = *s - 'a';
return GRAM_WORD;
} /* word_to_var */

dot_to_poly()
{
ZC_inp_parseval.POLY = dotval;
return GRAM_NUMBER;
} /* dot_to_poly */

struct POLY *mathop(p1, op, p2)
struct POLY *p1 , *p2;
{
struct POLY *q = &pzero;

switch(op) {
case TOK_PLUS:
if(!p1) p1 = &pzero;
q = radd(p1, p2);
break;
case TOK_MINUS:
if(!p1) p1 = &pzero;
q = rsub(p1, p2);
break;
case TOK_STAR:
q = rmul(p1, p2);
break;
case TOK_SLASH:
q = rdiv(p1, p2);
break;
case TOK_MOD:
q = rrem(p1, p2);
break;
case TOK_POWER:
if(!isconst(p2)) { eprint(er_const); break; }
q = rexp(p1, p2->terms[0].coef);
break;
case TOK_CHOOSE:
if(!isconst(p2)) { eprint(er_const); break; }
q = rchoose(p1, p2->terms[0].coef);
break;
default: eprint("@default[1] %d in bcgram.ec", op);
} /* end switch on math operator */
return q; /* the answer */
} /* mathop */

struct POLY * sym_to_poly(vn)
{
struct POLY *p;

if(!quoteflag && vbr[vn] == 1) {
p = vb[vn];
} else {
p = newpoly(1);
p->terms[0].coef = &ione;
p->terms[0].nvars = 1;
p->terms[0].degree = 1;
p->terms[0].vars[0] = vn;
p->terms[0].exps[0] = 1;
}
return p;
} /* sym_to_poly */

struct POLY *pbang(p)
struct POLY *p;
{
struct POLY *q = &pzero;
struct VINT *t;

if(!isconst(p)) eprint(er_const);
else {
t = p->terms[0].coef;
if(t->size < 0)
eprint("negative factorial");
else if(t->size > 1)
eprint("factorial too large");
else {
t = vbang(t);
q = newpoly(1);
q->terms[0].coef = t;
}
}
return q;
} /* pbang */

long addbit(list, n) long list; { return (1L << n) | list; }


/* end of generated source file, copy this comment just to make sure
 * we aren't out of disk space.  The source copy routine checks for this. */
